document.getElementById('description-form').addEventListener('submit', function(event) {
    event.preventDefault();

    const bookName = document.getElementById('book-name').value;
    const bookAuthor = document.getElementById('book-author').value;
    const errorArea = document.getElementById('error-area');
    errorArea.style.display = 'none';
    
    fetch('api.php', {
        method: 'POST',
        headers: {
            'Content-Type': 'application/x-www-form-urlencoded',
        },
        body: `book-name=${encodeURIComponent(bookName)}&book-author=${encodeURIComponent(bookAuthor)}`,
    })
    .then(response => {
      if(!response.ok){
        return response.text().then(text => {throw new Error(text)})
      }
      return response.json()
    })
    .then(data => {
      if(data.error) {
        errorArea.textContent = data.error;
        errorArea.style.display = 'block';
        return
      }
      const descriptionArea = document.getElementById('description-area');
        descriptionArea.style.display = 'block';
      const generatedDescription = document.getElementById('generated-description');
      generatedDescription.textContent = data.description;
      
    })
    .catch(error => {
        console.error('Error fetching description:', error);
      errorArea.textContent = "Error fetching description: " + error;
      errorArea.style.display = 'block';
    });
});
document.getElementById('copy-button').addEventListener('click', function() {
    const descriptionText = document.getElementById('generated-description').textContent;

    navigator.clipboard.writeText(descriptionText)
        .then(() => {
            alert('Description copied to clipboard!');
        })
        .catch(err => {
            console.error('Failed to copy text: ', err);
            alert('Failed to copy description.');
        });
});