<?php
session_start();

// Check if the user is logged in
if (!isset($_SESSION['loggedin']) || $_SESSION['loggedin'] !== true) {
    header('Location: login.php'); // Redirect to the login page if not logged in
    exit;
}
// Function to load JSON data
    function loadJsonData($jsonFile) {
        if (file_exists($jsonFile)) {
            $jsonData = file_get_contents($jsonFile);
            return json_decode($jsonData, true);
        } else {
            return ['urls' => []]; // Return an empty urls array if the file doesn't exist
        }
    }
  function loadApiData($jsonFile) {
        if (file_exists($jsonFile)) {
            $jsonData = file_get_contents($jsonFile);
            return json_decode($jsonData, true);
        } else {
            return ['apis' => []]; // Return an empty apis array if the file doesn't exist
        }
    }

    $freeJsonFile = 'freeapiurl.json';
    $paidJsonFile = 'paidapiurl.json';
    $apiJsonFile = 'APIs.json';

    $freeData = loadJsonData($freeJsonFile);
    $paidData = loadJsonData($paidJsonFile);
    $apiData = loadApiData($apiJsonFile);

    $freeApiUrls = array_column($freeData['urls'], 'url');
    $paidApiUrls = array_column($paidData['urls'], 'url');

    $filteredApiKeys = [];
    $filteredApiNames = [];
    $filteredApiVoiceIds = [];

    if (isset($apiData['apis']) && is_array($apiData['apis'])) {
    foreach ($apiData['apis'] as $api) {
        if (!isset($api['quota_exceeded']) || $api['quota_exceeded'] !== true) {
            $filteredApiKeys[] = $api['xi-api-key'];
            $filteredApiNames[] = $api['name'];
             if(isset($api['voice_ids'])){
                  $filteredApiVoiceIds[] = $api['voice_ids'];
              }
            }
        }
    }
?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Text to Speech</title>
    <link rel="stylesheet" href="style.css?v=0.1" data-precedence="next"/>
</head>
<body>
    <textarea id="text-input" rows="5" placeholder="Enter your text here..."></textarea>
    <div id="text-stats"></div>

      <!-- Wrap the two select elements in a flexbox container -->
    <div class="select-container">

         <label for="narrator-select">Select Voice:</label>
        <select id="narrator-select" class="form-control">
            <option value="nPczCjzI2devNBz1zQrb">Brian</option>
            <option value="JBFqnCBsd6RMkjVDRZzb">George</option>
             <option value="iP95p4xoKVk53GoZ742B">Chris</option>
             <option value="onwK4e9ZLuTAKqWW03F9">Daniel</option>
             <option value="pqHfZKP75CvOlQylNhV4">Bill</option>
             <option value="bIHbv24MWmeRgasZH58o">Will</option>
             <option value="pNInz6obpgDQGcFmaJgB">Adam</option>
          <option value="marcus">Marcus</option>
             <option value="neal">Neal</option>
            <option value="victoria">Victoria</option>

        </select>
    </div>

    <input id="title-input" type="text" placeholder="Enter file name (optional)" style="width: 80%; margin-bottom: 10px; border-radius:10px;padding: 5px; font-size: 14px;box-shadow: inset 9px 9px 16px #bebebe, inset -9px -9px 16px #ffffff;border: 1px solid black;">
    <button onclick="confirmConversion()">Convert to Speech</button>
    <div id="audio-container"></div>
    <div id="elapsed-time">Time Taken: 0s</div>
    <div id="log-box"></div>

    <div id="progress">Progress: 0%</div>
    <div id="progress-bar">
        <div id="progress-bar-inner">
        </div>
    </div>

    <br>

    <br><br><br><br>
<button id="goToLinkButton" style="color: blue; text-decoration: none;" onclick="window.open('usage.php', '_blank', 'noopener,noreferrer')">
Fetch All Api Usage</button>
<button id="goToLinkButton" style="color: blue; text-decoration: none;" onclick="window.open('addnewapikey.php', '_blank', 'noopener,noreferrer')">
    Add New API Key
</button>
  <button id="goToLinkButton" style="color: blue; text-decoration: none;" onclick="window.open('addApiUrl.php', '_blank', 'noopener,noreferrer')">
    Add New API Url
</button>
<button id="goToLinkButton" style="color: blue; text-decoration: none;" onclick="window.open('logout.php', '_blank', 'noopener,noreferrer')">
    Logout
</button>
<br>    <br><br><br><br>


    <script>
        // Restore text and file name after a page refresh
        window.addEventListener('load', () => {
            const savedText = localStorage.getItem('text-input');
            const savedFileName = localStorage.getItem('title-input');
            if (savedText) document.getElementById('text-input').value = savedText;
            if (savedFileName) document.getElementById('title-input').value = savedFileName;

        });

        // Save inputs to local storage
        document.getElementById('text-input').addEventListener('input', () => {
            localStorage.setItem('text-input', document.getElementById('text-input').value);
        });
        document.getElementById('title-input').addEventListener('input', () => {
            localStorage.setItem('title-input', document.getElementById('title-input').value);
        });


        // Reference to the textarea and text stats container
        const textArea = document.getElementById("text-input");
        const textStats = document.getElementById("text-stats");
        // Text stats calculation
        textArea.addEventListener("input", updateTextStats);
        function updateTextStats() {
            const text = textArea.value;
            const charCount = text.length;
            const wordCount = text.trim().split(/\s+/).filter(Boolean).length; // Avoid counting empty strings as words
            const paragraphCount = text.split(/\n\s*\n/).filter(Boolean).length; // Avoid counting empty strings as paragraphs

            textStats.textContent = `Characters: ${charCount} | Words: ${wordCount} | Paragraphs: ${paragraphCount}`;
        }

        function splitTextIntoChunks(text, chunkSize = 400) {
            const chunks = [];
            const paragraphs = text.split(/\n+/); // Split text into paragraphs

            paragraphs.forEach(paragraph => {

                paragraph = paragraph.replace(/[*#\[\]\(\)]/g, ' ') // Remove * # and brackets
                    .replace(/-{2,}/g, '') // Reduce two or more dashes to one
                    .replace(/\s+/g, ' ') // Replace multiple spaces with one space
                    .trim(); // Remove leading and trailing spaces

                if (paragraph.length === 0) return; // Skip if the paragraph is empty

                let start = 0;

                while (start < paragraph.length) {
                    let end = start + chunkSize;

                    if (end < paragraph.length) {
                        // Find the last punctuation before the chunk ends
                        let lastPunctuation = Math.max(
                            paragraph.lastIndexOf('.', end),
                            paragraph.lastIndexOf('!', end),
                            paragraph.lastIndexOf('?', end),
                            paragraph.lastIndexOf(',', end),
                             paragraph.lastIndexOf('।', end),
                             paragraph.lastIndexOf(':', end)
                        );

                        // Fallback to the last space if no punctuation or punctuation is too close to start
                        if (lastPunctuation > start) {
                            end = lastPunctuation + 1; // Include punctuation
                        } else {
                            let lastSpace = paragraph.lastIndexOf(' ', end);
                            if (lastSpace > start) {
                                end = lastSpace; // Fall back to the last space
                            }
                        }
                    }

                    const chunk = paragraph.slice(start, end).trim();
                    if (chunk.length > 0) {
                        chunks.push(chunk); // Add the chunk only if it's not empty
                    }
                    start = end;
                }
            });

            return chunks;
        }

        // Added confirmation dialog
        function confirmConversion() {
            if (confirm("Are you sure you want to convert the text? This will clear the previous audio.")) {
                convertTextToSpeech();
            }
        }

  const PaidapiUrls = <?php echo json_encode($paidApiUrls); ?>;
  const FreeapiUrls =  <?php echo json_encode($freeApiUrls); ?>;


        async function convertTextToSpeech() {
             const narratorSelect = document.getElementById('narrator-select');
            const selectedNarrator = narratorSelect.value;

            const text = document.getElementById('text-input').value;
            const elapsedTimeDisplay = document.getElementById('elapsed-time');
            const titleInput = document.getElementById('title-input').value.trim();
            const audioContainer = document.getElementById('audio-container');
            const logBox = document.getElementById('log-box');
            const progressIndicator = document.getElementById('progress');
            const progressBar = document.getElementById('progress-bar-inner');

            logBox.innerHTML = '';
            audioContainer.innerHTML = '';
            elapsedTimeDisplay.textContent = 'Time Taken: 0s';

            if (text.length === 0) {
                  return;
            }

            const startTime = Date.now();
            let timerInterval;

            function startTimer() {
                timerInterval = setInterval(() => {
                    const elapsedTimeInSeconds = (Date.now() - startTime) / 1000;
                    const hours = Math.floor(elapsedTimeInSeconds / 3600);
                    const minutes = Math.floor((elapsedTimeInSeconds % 3600) / 60);
                    const seconds = Math.floor(elapsedTimeInSeconds % 60);
                    const formattedTime = `${hours.toString().padStart(2, '0')}h:${minutes.toString().padStart(2, '0')}m:${seconds.toString().padStart(2, '0')}s`;
                    elapsedTimeDisplay.textContent = `Time Taken: ${formattedTime}`;
                }, 1000);
            }

            function stopTimer() {
                clearInterval(timerInterval);
            }

            startTimer();
            const chunks = splitTextIntoChunks(text, 400);
              let completedChunks = 0;
            let apiKeys = <?php echo json_encode($filteredApiKeys); ?>;
            let apiNames =  <?php echo json_encode($filteredApiNames); ?>;
             let apiVoiceIds =  <?php echo json_encode($filteredApiVoiceIds); ?>;
            let audioBlobs = [];
              let apiQuotaExceeded = {};
            try{
              apiQuotaExceeded =  JSON.parse(localStorage.getItem('apiQuotaExceeded')) || {};
            }catch(e){
              apiQuotaExceeded = {};
            }

           if(selectedNarrator === "marcus" || selectedNarrator === "neal" || selectedNarrator === "victoria"){
                   //process in the same way
                let chunkIndex = 0;
                async function processChunk() {
                   if (chunkIndex >= chunks.length) {
                       const mergedBlob = new Blob(audioBlobs, { type: 'audio/mpeg' });
                       const audioUrl = URL.createObjectURL(mergedBlob);
                        const currentTime = new Date().toISOString().replace(/[:.]/g, '-');
                        const fileName = titleInput ? `${titleInput}-${currentTime}.mp3` : `${currentTime}.mp3`;
                             audioContainer.innerHTML = `
                                <audio id="generated-audio" controls>
                                    <source src="${audioUrl}" type="audio/mpeg">
                                    Your browser does not support the audio element.
                                </audio>
                                <a href="${audioUrl}" download="${fileName}">Download Audio</a>
                            `;
                            stopTimer();
                           progressIndicator.textContent = 'Progress: 100% - Conversion Complete!';
                            progressBar.style.width = '100%';
                            updateLogBox('<p>Conversion complete!</p>');
                            document.getElementById('generated-audio').play();
                     return;
                    }
                let chunk = chunks[chunkIndex];
                    let success = false;
                    let retries = 0;
                     let currentApiUrl = null;
                     let apiKeyIndex = 0;
                     let apiKey = null;
                     let currentApiKeyName = null;
                     let currentVoiceId = null;
                      let headers = {
                            'Content-Type': 'application/json',
                         };
                    currentApiUrl = PaidapiUrls[chunkIndex % PaidapiUrls.length];
                           while (!success && retries < 1000) {
                            apiKey = apiKeys[apiKeyIndex % apiKeys.length];
                            currentApiKeyName = apiNames[apiKeyIndex % apiNames.length];
                            const voiceIds = apiVoiceIds[apiKeyIndex % apiVoiceIds.length];

                             if(voiceIds && voiceIds[selectedNarrator]){
                                 currentVoiceId = voiceIds[selectedNarrator];
                             } else {
                                    updateLogBox(`<p style="color:red;">Error: Voice ID not found for ${selectedNarrator} with key ${currentApiKeyName}. Trying next API.</p>`);
                                    retries++;
                                    currentApiUrl = PaidapiUrls[(chunkIndex + retries) % PaidapiUrls.length];
                                    apiKeyIndex++;
                                    if (apiKeyIndex >= apiKeys.length) {
                                          apiKeyIndex = 0;
                                    }
                                    continue;
                                }
                                  // Check if the current API key is flagged and within the 30-day cooldown
                                    if (apiQuotaExceeded[apiKey] && Date.now() < apiQuotaExceeded[apiKey]) {
                                          updateLogBox(`<p style="color:orange;">Skipping API Key: ${currentApiKeyName} due to quota exceeded. Will try with the next Key...</p>`);
                                          retries++;
                                           currentApiUrl = PaidapiUrls[(chunkIndex + retries) % PaidapiUrls.length];
                                            apiKeyIndex++;
                                            if (apiKeyIndex >= apiKeys.length) {
                                                  apiKeyIndex = 0;
                                             }
                                          continue;
                                   }
                                headers['xi-api-key'] = apiKey;
                            updateLogBox(`<p>Sending chunk no ${chunkIndex + 1} \n ${chunk}\nusing API URL: ${currentApiUrl}. Using API Key: ${currentApiKeyName}. Voice ID: ${currentVoiceId} . Retry count: ${retries}</p>`);
                            logBox.scrollTop = logBox.scrollHeight;
                                try {
                                 const response = await fetch(currentApiUrl + "?v=" + Math.random().toString(36).substring(7), {
                                        method: 'POST',
                                        headers: headers,
                                        body: JSON.stringify({ text: chunk, narratorId: currentVoiceId, xiapikey: apiKey }),
                                    });

                                    if (response.ok && response.headers.get("Content-Type").includes("audio")) {
                                        const blob = await response.blob();
                                        audioBlobs.push(blob);
                                        success = true;
                                        completedChunks++;

                                        const progressPercentage = Math.round((completedChunks / chunks.length) * 100);
                                        progressIndicator.textContent = `Progress: ${progressPercentage}%`;
                                        progressBar.style.width = `${progressPercentage}%`;
                                    } else {
                                        retries++;
                                        currentApiUrl = PaidapiUrls[(chunkIndex + retries) % PaidapiUrls.length];
                                        apiKeyIndex++;
                                        if (apiKeyIndex >= apiKeys.length) {
                                              apiKeyIndex = 0;
                                         }
                                           const errorData = await response.json();
                                             if(errorData.detail && errorData.detail.status && errorData.detail.status.includes("quota_exceeded")){
                                               const thirtyDaysFromNow = Date.now() + (30 * 24 * 60 * 60 * 1000);
                                               apiQuotaExceeded[apiKey] = thirtyDaysFromNow;
                                                localStorage.setItem('apiQuotaExceeded', JSON.stringify(apiQuotaExceeded));
                                                updateLogBox(`<p style="color:red;">Error on chunk ${chunkIndex + 1}: ${errorData.detail.status}. API Key: ${currentApiKeyName} Flagged for 30 days. Retry ${retries}/1000...</p>`);
                                              }else{
                                                updateLogBox(`<p style="color:red;">Error on chunk ${chunkIndex + 1}: ${errorData.detail.status}. Retry ${retries}/1000...</p>`);
                                             }


                                      }
                                 } catch (error) {
                                       retries++;
                                        currentApiUrl = PaidapiUrls[(chunkIndex + retries) % PaidapiUrls.length];
                                        apiKeyIndex++;
                                        if (apiKeyIndex >= apiKeys.length) {
                                              apiKeyIndex = 0;
                                         }
                                       updateLogBox(`<p style="color:red;">Network error on chunk ${chunkIndex + 1}: ${error.message}. Retry ${retries}/1000...</p>`);
                                   }
                             }
                   if (!success) {
                        updateLogBox(`<p style="color:red;">Failed to convert chunk ${chunkIndex + 1} after 1000 attempts.</p>`);
                      }
                    chunkIndex++;
                   processChunk();
                  }
                processChunk();
           }else{
                 const processFreeChunks = async () => {
                      let chunkIndex = 0;
                     while (chunkIndex < chunks.length) {
                        const chunkBatch = chunks.slice(chunkIndex, chunkIndex + 10);
                        if (chunkBatch.length === 0) break;
                         const batchAudioBlobs = await processChunkBatch(chunkBatch, chunkIndex);
                         if(batchAudioBlobs){
                             audioBlobs.push(...batchAudioBlobs);
                         }
                            chunkIndex += 10;
                           completedChunks += chunkBatch.length;
                            const progressPercentage = Math.round((completedChunks / chunks.length) * 100);
                            progressIndicator.textContent = `Progress: ${progressPercentage}%`;
                            progressBar.style.width = `${progressPercentage}%`;

                        }


                    const mergedBlob = new Blob(audioBlobs, { type: 'audio/mpeg' });
                    const audioUrl = URL.createObjectURL(mergedBlob);
                     const currentTime = new Date().toISOString().replace(/[:.]/g, '-');
                    const fileName = titleInput ? `${titleInput}-${currentTime}.mp3` : `${currentTime}.mp3`;

                    audioContainer.innerHTML = `
                        <audio id="generated-audio" controls>
                            <source src="${audioUrl}" type="audio/mpeg">
                            Your browser does not support the audio element.
                        </audio>
                        <a href="${audioUrl}" download="${fileName}">Download Audio</a>
                    `;
                      stopTimer();
                    progressIndicator.textContent = 'Progress: 100% - Conversion Complete!';
                      progressBar.style.width = '100%';
                    updateLogBox('<p>Conversion complete!</p>');
                      document.getElementById('generated-audio').play();
                 }


                const processChunkBatch = async (chunkBatch, chunkIndexStart) => {
                   const batchAudioBlobs = new Array(chunkBatch.length);
                   const promises = chunkBatch.map(async (chunk, index) => {
                        let success = false;
                        let retries = 0;
                        let currentApiUrl = FreeapiUrls[(chunkIndexStart + index) % FreeapiUrls.length];
                       let currentVoiceId = selectedNarrator;
                       let headers = {
                            'Content-Type': 'application/json',
                         };
                         while(!success && retries < 1000){
                              try {
                                    updateLogBox(`<p>Sending chunk no ${chunkIndexStart + index + 1} \n ${chunk}\nusing Free API URL: ${currentApiUrl}. Using Voice ID: ${currentVoiceId} . Retry count: ${retries}</p>`);
                                   logBox.scrollTop = logBox.scrollHeight;
                                 const response = await fetch(currentApiUrl + "?v=" + Math.random().toString(36).substring(7), {
                                    method: 'POST',
                                    headers: headers,
                                    body: JSON.stringify({ text: chunk, narratorId: currentVoiceId }),
                                 });


                                if (response.ok && response.headers.get("Content-Type").includes("audio")) {
                                     const blob = await response.blob();
                                     batchAudioBlobs[index] = blob;
                                   success = true;
                                } else {
                                   retries++;
                                  currentApiUrl = FreeapiUrls[(chunkIndexStart + index + retries) % FreeapiUrls.length];
                                    const errorData = await response.json();
                                   updateLogBox(`<p style="color:red;">Error on chunk ${chunkIndexStart + index + 1}: ${errorData.detail.status}. Retry ${retries}/1000...</p>`);
                                 }
                            } catch (error) {
                               retries++;
                              currentApiUrl = FreeapiUrls[(chunkIndexStart + index + retries) % FreeapiUrls.length];
                                updateLogBox(`<p style="color:red;">Network error on chunk ${chunkIndexStart + index + 1}: ${error.message}. Retry ${retries}/1000...</p>`);
                             }
                         }
                           if (!success) {
                                updateLogBox(`<p style="color:red;">Failed to convert chunk ${chunkIndexStart + index + 1} after 1000 attempts.</p>`);
                            }

                    });

                    await Promise.all(promises);
                   return batchAudioBlobs.filter(blob => blob !== undefined);
                };

               await processFreeChunks();
            }
        }
        // Function to limit logs in the logBox
        function updateLogBox(newLog) {
             const logBox = document.getElementById('log-box');
             logBox.innerHTML += newLog;
            const logs = logBox.getElementsByTagName('p');

            // Remove all but the last two logs
            while (logs.length > 50) {
                logBox.removeChild(logs[0]);
            }

            logBox.scrollTop = logBox.scrollHeight; // Ensure the latest log is visible
        }

        // Global variable for usage table container
         const fetchAllUsageButton = document.getElementById("fetchAllUsageButton");
         const goToLinkButton = document.getElementById("goToLinkButton");


       async function loadApis() {
              const cachedData = localStorage.getItem('apiData');
              const cachedTime = localStorage.getItem('apiDataTime');
              const now = Date.now();
           if (cachedData && cachedTime && now - parseInt(cachedTime) < 24 * 60 * 60 * 1000) {
                  try {
                    return JSON.parse(cachedData);
                    } catch (e) {
                    console.error("Error parsing cached API data:", e);
                       localStorage.removeItem('apiData');
                        localStorage.removeItem('apiDataTime');
                   }
                }
                try {
                   const response = await fetch("APIs.json");
                     const data = await response.json();
                    localStorage.setItem('apiData', JSON.stringify(data));
                   localStorage.setItem('apiDataTime', now.toString());
                  return data;
                  } catch (error) {
                    console.error("Error loading APIs:", error);
                     throw error;
                  }
       }


        // Load APIs when the page is ready
        window.addEventListener("load", async () => {
             try{
               await loadApis();
             }catch(e){
                 console.error("Failed to load APIs on page load:", error);
              }
        });
    </script>
</body>
</html>