<?php
session_start();

// Check if the user is logged in
if (!isset($_SESSION['loggedin']) || $_SESSION['loggedin'] !== true) {
    header('Location: login.php');
    exit;
}

// Function to load JSON data
function loadJsonData($jsonFile) {
    if (file_exists($jsonFile)) {
        $jsonData = file_get_contents($jsonFile);
        return json_decode($jsonData, true);
    } else {
        return ['apis' => []]; // Return an empty apis array if the file doesn't exist
    }
}

// Function to save JSON data
function saveJsonData($jsonFile, $data) {
    file_put_contents($jsonFile, json_encode($data, JSON_PRETTY_PRINT));
}

$apiJsonFile = 'APIs.json';
$apiData = loadJsonData($apiJsonFile);

// Handle POST request to update quota_exceeded status
if ($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_POST['flaggedKeys'])) {
      $flaggedKeys = json_decode($_POST['flaggedKeys']);
     if (isset($apiData['apis']) && is_array($apiData['apis'])) {
           foreach ($apiData['apis'] as &$api) {
              if(in_array($api['name'], $flaggedKeys)){
                   $api['quota_exceeded'] = true;
              }else{
                   $api['quota_exceeded'] = false;
              }
           }
           saveJsonData($apiJsonFile, $apiData);
     }
}
?>