<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Study Materials by AmarSir</title>
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.6.0/css/all.min.css" integrity="sha512-Kc323vGBEqzTmouAECnVceyQqyqdsSiqLQISBL29aUW4U/M7pSPA/gEUZQqv1cwx4OnYxTxve5UMg5GT6L4JJg==" crossorigin="anonymous" referrerpolicy="no-referrer" />
<style>
body {
    font-family: Arial, sans-serif;
    margin: 0;
    padding: 0;
    background-color: #ecf0f3;
    display: flex;
    flex-direction: column;
    height: 100vh;
}

h1 {
    text-align: center;
    color: teal;
}

h2 {
    text-align: center;
    color: black;
}

.pdf-list {
    list-style: none;
    padding: 0;
}

.pdf-list li {
    margin: 10px 0;
    padding: 15px;
    background-color: #fff;
    border-radius: 8px;
    box-shadow: 0 2px 5px rgba(0, 0, 0, 0.1);
    transition: transform 0.2s ease;
}

.pdf-list li:hover {
    transform: translateY(-3px);
}

a {
    text-decoration: none;
    color: #E94E77;
    font-weight: bold;
}

.message {
    color: red;
    text-align: center;
    margin: 20px 0;
}

.button-container {
    list-style: none;
    padding: 0;
}

.button-container form {
    margin: 10px 0;
}

button {
    width: 100%;
    padding: 15px;
    font-size: 20px;
    font-weight: 1000;
    color: white;
    background-color: #E94E77;
    border: none;
    border-radius: 8px;
    box-shadow: 0 2px 5px rgba(0, 0, 0, 0.1);
    cursor: pointer;
    transition: background-color 0.3s ease, transform 0.2s ease;
    margin: 2px;
}

button:hover {
    background-color: #D4426B;
    transform: translateY(-3px);
}

@media (min-width: 768px) {
    .pdf-list li {
        margin: 15px 0;
    }

    button {
        width: 80%;
        margin: 0 auto;
    }
}

.content-container {
    flex-grow: 1;
    align-items: center;
    padding: 5px;
    margin: 10px;
    background-color: #ecf0f3;
    border-radius: 10px 10px 0 0; /* Curved top corners */
    box-shadow: 9px 9px 16px #d1d9e6, -9px -9px 16px #ffffff;
    transition: all 0.3s ease;
}

.content {
    display: none;
}

.content.active {
    display: block;
}

.menu {
    position: fixed;
    bottom: 0;
    width: 100%;
    display: flex;
    justify-content: space-around;
    background-color: #ecf0f3;
    padding: 10px 0;
    border-radius: 30px 30px 0 0; /* Curved top corners */
    box-shadow: 9px 9px 16px #d1d9e6, -9px -9px 16px #ffffff;
    transition: all 0.3s ease;
}

.menu-item {
    display: flex;
    flex-direction: column;
    align-items: center;
    cursor: pointer;
    padding: 10px;
    border-radius: 10px;
    background: #ecf0f3;
    box-shadow: inset 5px 5px 10px #bec8d2, inset -5px -5px 10px #ffffff;
    transition: all 0.3s ease;
}

.menu-item.active {
    background: #007bff; /* Highlight color for selected tab */
    color: white;
    box-shadow: 9px 9px 16px #0062cc, -9px -9px 16px #3399ff;
}

.menu-item i {
    font-size: 24px;
    color: #333;
    transition: color 0.3s ease;
}

.menu-item.active i {
    color: white;
}

.menu-item span {
    margin-top: 5px;
    font-size: 12px;
    color: #333;
}

.menu-item.active span {
    color: white;
}

.menu-item:hover {
    box-shadow: inset 5px 5px 10px #d1d9e6, inset -5px -5px 10px #ffffff;
}

.container {
    display: flex;
    flex-wrap: wrap;
    justify-content: center;
    margin-top: 5px;
    border-radius: 12px;
    border: 2px solid #008080;
}

.card {
    display: flex;
    align-items: center;
    width: 40%; /* Adjust width as needed */
    background-color: #FFFFFF;
    border: 2px solid #008080; /* Teal border */
    border-radius: 12px;
    box-shadow: 0px 4px 4px rgba(0, 0, 0, 0.25), 0px 2px 2px rgba(0, 0, 0, 0.25), inset 0px -2px 2px rgba(0, 0, 0, 0.25);
    margin: 1px;
    padding: 10px;
    text-decoration: none;
    color: #333;
}

.card:hover {
    box-shadow: 0px 8px 8px rgba(0, 0, 0, 0.25), 0px 4px 4px rgba(0, 0, 0, 0.25), inset 0px -4px 4px rgba(0, 0, 0, 0.25);
    transform: translateY(-3px);
}

.card i {
    font-size: 40px; /* Increase the size of the icon */
    margin-right: 10px;
    color: #4285F4; /* Google Blue */
}

.card-icon {
    width: 40px; /* Adjust icon size */
    height: 40px;
    margin-right: 20px;
    border-radius: 50%; /* Optional: Add circular styling */
}

.card p {
    font-size: 15px;
    line-height: 1.2;
    font-weight: 600;
    flex-grow: 1; /* Allows the text to take up remaining space */
    margin: 0;
    text-align: left;
    white-space: normal; /* Allows text to wrap */
    word-break: break-word; /* Breaks long words */
    overflow-wrap: break-word;
}

.header {
    width: auto; /* Adjust width as needed */
    height: auto;
    background-color: #008080;
    color: #FFFFFF;
    padding: 0; /* Reduced padding */
    border-radius: 10px;
    box-shadow: 0px 4px 4px rgba(0, 0, 0, 0.25), 0px 2px 2px rgba(0, 0, 0, 0.25), inset 0px -2px 2px rgba(0, 0, 0, 0.25);
    margin: 5px;
}

.search-bar {
    margin: 20px auto;
    display: flex;
    justify-content: center;
    align-items: center;
}

.search-bar input {
    padding: 10px;
    width: 80%;
    max-width: 500px;
    border: 2px solid #008080;
    border-radius: 12px;
    box-shadow: 0px 4px 4px rgba(0, 0, 0, 0.25), 0px 2px 2px rgba(0, 0, 0, 0.25), inset 0px -2px 2px rgba(0, 0, 0, 0.25);
}

</style>
    
    <script>
        function showTab(tab) {
            var contents = document.querySelectorAll('.content');
            var menuItems = document.querySelectorAll('.menu-item');
            contents.forEach(content => content.classList.remove('active'));
            menuItems.forEach(item => item.classList.remove('active'));

            document.getElementById(tab).classList.add('active');
            document.querySelector(`[data-tab="${tab}"]`).classList.add('active');
        }
    </script>
</head>
<body>

    <div class="content-container">
        <?php
        // Load the appropriate content based on the 'tab' parameter
        $tab = isset($_GET['tab']) ? $_GET['tab'] : 'home';
        switch ($tab) {
            case 'notifications':
                include 'notifications.php';
                break;
            case 'quotes':
                include 'quotes.php';
                break;
            case 'home':
            default:
                include 'home.php';
                break;
        }
        ?>
    </div>
<br><br><br>  <br>  <br>  

    <div class="menu">
        <div class="menu-item <?php echo ($tab == 'home') ? 'active' : ''; ?>" data-tab="home" onclick="location.href='?tab=home'">
            <i class="fas fa-home"></i>
            <span>Home</span>
        </div>
        <div class="menu-item <?php echo ($tab == 'notifications') ? 'active' : ''; ?>" data-tab="notifications" onclick="location.href='?tab=notifications'">
            <i class="fas fa-bell"></i>
            <span>Short News</span>
        </div>
        
        <div class="menu-item <?php echo ($tab == 'quotes') ? 'active' : ''; ?>" data-tab="quotes" onclick="location.href='?tab=quotes'">
            <i class="fas fa-quote-right"></i>
            <span>Quotes</span>
        </div>
        
    </div>

  <script>
    function searchCards() {
      let input = document.getElementById('searchInput').value.toLowerCase();
      let headers = document.querySelectorAll('.header');
      let containers = document.querySelectorAll('.container');

      containers.forEach((container, index) => {
        let cards = container.querySelectorAll('.card');
        let hasVisibleCards = false;

        cards.forEach(card => {
          let text = card.textContent.toLowerCase();
          if (text.includes(input)) {
            card.style.display = '';
            hasVisibleCards = true;
          } else {
            card.style.display = 'none';
          }
        });

        if (hasVisibleCards) {
          headers[index].style.display = '';
          container.style.display = '';
        } else {
          headers[index].style.display = 'none';
          container.style.display = 'none';
        }
      });
    }
  </script>

</body>
</html>
