<?php

// --- Configuration ---
$botToken = '7953757803:AAHc0TwnK94iduI_4ALx4ki7cxMqpsgDvd4'; // Replace with your actual bot token
$apiURL = "https://api.telegram.org/bot{$botToken}";
$redirectFile = 'redirect_urls.json'; // File to store redirect URLs

// --- Helper Functions ---

function sendMessage($chatId, $text, $replyMarkup = null) {
    global $apiURL;
    $url = $apiURL . "/sendMessage";
    $postData = [
        'chat_id' => $chatId,
        'text' => $text,
        'reply_markup' => $replyMarkup,
    ];
    $ch = curl_init();
    curl_setopt_array($ch, [
        CURLOPT_URL => $url,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_POST => true,
        CURLOPT_POSTFIELDS => $postData,
    ]);
    curl_exec($ch);
    curl_close($ch);
}

function getRedirectUrls($redirectFile) {
    if (file_exists($redirectFile)) {
        $json = file_get_contents($redirectFile);
        return json_decode($json, true) ?: ['image' => '', 'audio' => ''];
    } else {
        return ['image' => '', 'audio' => ''];
    }
}

function saveRedirectUrls($redirectFile, $urls) {
    $json = json_encode($urls, JSON_PRETTY_PRINT); // Added JSON_PRETTY_PRINT for better readability
    file_put_contents($redirectFile, $json);
}

// --- Main Logic ---

$update = json_decode(file_get_contents('php://input'), true);

if (isset($update['message'])) {
    $message = $update['message'];
    $chatId = $message['chat']['id'];
    $text = $message['text'];
    $messageId = $message['message_id'];

    if (strpos($text, '/') === 0) { // Check if it's a command
        $commandParts = explode(' ', $text, 2); // Split command and arguments
        $command = strtolower(ltrim($commandParts[0], '/')); // Remove leading slash and lowercase
        $url = isset($commandParts[1]) ? trim($commandParts[1]) : ''; // Get the URL argument

        $redirectUrls = getRedirectUrls($redirectFile);
        $response = "";

        switch ($command) {
            case 'start':
                $response = "Hello! Use /image <url> or /audio <url> to update the redirect URLs.\nUse /show to see current URLs.";
                break;
            case 'image':
                if (empty($url)) {
                    $response = "Please provide a URL after /image command.";
                } else {
                    $redirectUrls['image'] = $url;
                    saveRedirectUrls($redirectFile, $redirectUrls);
                    $response = "Image URL updated to: " . $url . "\n\nCurrent URLs:\n" . file_get_contents($redirectFile);
                }
                break;
            case 'audio':
                if (empty($url)) {
                    $response = "Please provide a URL after /audio command.";
                } else {
                    $redirectUrls['audio'] = $url;
                    saveRedirectUrls($redirectFile, $redirectUrls);
                    $response = "Audio URL updated to: " . $url . "\n\nCurrent URLs:\n" . file_get_contents($redirectFile);
                }
                break;
            case 'video':
                if (empty($url)) {
                    $response = "Please provide a URL after /video command.";
                } else {
                    $redirectUrls['video'] = $url;
                    saveRedirectUrls($redirectFile, $redirectUrls);
                    $response = "Video URL updated to: " . $url . "\n\nCurrent URLs:\n" . file_get_contents($redirectFile);
                }
                break;
            case 'show':
                $response = "Current Redirect URLs:\n" . file_get_contents($redirectFile);
                break;
            default:
                $response = "Unknown command. Use /start, /image, /audio, or /show.";
        }
        sendMessage($chatId, $response);
    }
}

echo "ok"; // To acknowledge Telegram webhook