addEventListener('fetch', event => {
  event.respondWith(handleRequest(event.request));
});

function getRandomIp() {
  return `${getRandomInt(1, 255)}.${getRandomInt(1, 255)}.${getRandomInt(1, 255)}.${getRandomInt(1, 255)}`;
}

function getRandomInt(min, max) {
  return Math.floor(Math.random() * (max - min + 1)) + min;
}

function getRandomUserAgent() {
  
const browsers = [
    'Mozilla/5.0 (Linux; Android 10; Build/QQ3A.200805.001) AppleWebKit/537.36 (KHTML, like Gecko) Chrome',
    'Mozilla/5.0 (Linux; Android 9; Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Chrome',
    'Mozilla/5.0 (Linux; Android 11; Build/RP1A.200720.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome',
    'Mozilla/5.0 (Linux; Android 12; Build/SP1A.210812.016) AppleWebKit/537.36 (KHTML, like Gecko) Chrome',
    'Mozilla/5.0 (Linux; Android 13; Build/TKQ1.220917.001) AppleWebKit/537.36 (KHTML, like Gecko) Chrome',
    'Mozilla/5.0 (Linux; Android 10; Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Chrome',
    'Mozilla/5.0 (Linux; Android 8.1; Build/OPM1.171019.026) AppleWebKit/537.36 (KHTML, like Gecko) Chrome',
    'Mozilla/5.0 (Linux; Android 7.1.2; Build/N2G48H) AppleWebKit/537.36 (KHTML, like Gecko) Chrome',
    'Mozilla/5.0 (Linux; Android 6.0.1; Build/MMB29K) AppleWebKit/537.36 (KHTML, like Gecko) Chrome',
    'Mozilla/5.0 (Linux; Android 9; Build/PQ3A.190705.003) AppleWebKit/537.36 (KHTML, like Gecko) Chrome',
    'Mozilla/5.0 (Linux; Android 8.0.0; Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) Chrome',
    'Mozilla/5.0 (Linux; Android 5.1; Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Chrome',
    'Mozilla/5.0 (Linux; Android 11; Build/RKQ1.200826.002) AppleWebKit/537.36 (KHTML, like Gecko) Chrome',
    'Mozilla/5.0 (Linux; Android 10; Build/QP1A.190711.020) AppleWebKit/537.36 (KHTML, like Gecko) Chrome',
    'Mozilla/5.0 (Linux; Android 12; Build/SQ1D.210755.003) AppleWebKit/537.36 (KHTML, like Gecko) Chrome',
    'Mozilla/5.0 (Linux; Android 13; Build/TP1A.220905.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome',
    'Mozilla/5.0 (Linux; Android 9; Build/PKQ1.190605.001) AppleWebKit/537.36 (KHTML, like Gecko) Chrome',
    'Mozilla/5.0 (Linux; Android 8.1.0; Build/OPM2.171019.029) AppleWebKit/537.36 (KHTML, like Gecko) Chrome',
    'Mozilla/5.0 (Linux; Android 7.1.1; Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Chrome',
    'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/108.0.0.0 Safari/537.36',
    'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:99.0) Gecko/20100101 Firefox/99.0',
    'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:102.0) Gecko/20100101 Firefox/102.0',
    'Mozilla/5.0 (Windows NT 6.3; Trident/7.0; ASL 4.0; .NET CLR 4.0.30319; Tablet) like Gecko',
    'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:90.0) Gecko/20100101 Firefox/90.0',
    'Mozilla/5.0 (Linux; U; Android 4.4.4; en-us; Nexus 5 Build/KTU84P) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.0.0 Mobile Safari/537.36',
    'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Edge/105.0.1343.53 Safari/537.36',
    'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3865.120 Safari/537.36',
    'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/79.0.3945.88 Safari/537.36',
    'Mozilla/5.0 (Windows NT 6.1; rv:80.0) Gecko/20100101 Firefox/80.0',
    'Mozilla/5.0 (Windows NT 6.1; rv:66.0) Gecko/20100101 Firefox/66.0',
    'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/95.0.4638.69 Safari/537.36'
];

  const randomBrowser = browsers[Math.floor(Math.random() * browsers.length)];
  const version1 = getRandomInt(50, 130);
  const version2 = getRandomInt(0, 5000);
  const version3 = getRandomInt(0, 300);

  return `${randomBrowser}/${version1}.${version2}.${version3} Mobile Safari/537.36`;
}

async function handleRequest(request) {
  if (request.method === 'OPTIONS') {
    // Handle CORS preflight request
    return new Response(null, {
      headers: {
        'Access-Control-Allow-Origin': '*',
        'Access-Control-Allow-Methods': 'POST, OPTIONS',
        'Access-Control-Allow-Headers': 'Content-Type, xi-api-key, User-Agent, CF-Connecting-IP'
      }
    });
  }

  if (request.method !== 'POST') {
    return new Response(JSON.stringify({ error: 'Method not allowed' }), { status: 405 });
  }

  try {
    const requestData = await request.json();
    const text = requestData.text;
    const narratorId = requestData.narratorId || 'bIHbv24MWmeRgasZH58o';

    const apiUrl = `https://api.us.elevenlabs.io/v1/text-to-speech/${narratorId}?allow_unauthenticated=1`;

    const currentTime = new Date().toISOString().replace('T', ' ').split('.')[0]; // Format: 2024-10-25 09:58:18
    const contentLength = JSON.stringify(requestData).length;

    const apiResponse = await fetch(apiUrl, {
      method: 'POST',
      headers: {
        'Time': currentTime,
        'Size': contentLength,
        'X-Forwarded-For': getRandomIp(),
        'Host': 'api.elevenlabs.io',
        'Connection': 'keep-alive',
        'User-Agent': getRandomUserAgent(),
        'sec-ch-ua': '"Android WebView";v="129", "Not=A?Brand";v="8", "Chromium";v="129"',
        'Content-Type': 'application/json',
        'Accept': '*/*',
        'Origin': 'https://elevenlabs.io',
        'Referer': 'https://elevenlabs.io/',
        'Accept-Encoding': 'gzip, deflate, br, zstd',
        'Accept-Language': 'en-IN,en-US;q=0.9,en;q=0.8'
      },
      body: JSON.stringify({
        text: text,
        model_id: 'eleven_multilingual_v2'
      })
    });

    const headers = new Headers(apiResponse.headers);
    headers.set('Access-Control-Allow-Origin', '*');

    return new Response(apiResponse.body, {
      headers: headers,
      status: apiResponse.status
    });
  } catch (error) {
    return new Response(JSON.stringify({ error: 'Internal Server Error' }), {
      status: 500,
      headers: { 'Content-Type': 'application/json' }
    });
  }
}