<?php
if($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_POST['channelId']) && isset($_POST['channelUrl']) && isset($_POST['channelName'])) {
    $channelId = $_POST['channelId'];
    $channelUrl = $_POST['channelUrl'];
    $channelName = $_POST['channelName'];
    $videoFile = $channelId . "_videos.json";

    // Function to generate a random UUID-like string for the cookie
    function generateRandomCookie() {
        return sprintf('%04x%04x-%04x-%04x-%04x-%04x%04x%04x',
            mt_rand(0, 0xffff), mt_rand(0, 0xffff),
            mt_rand(0, 0xffff),
            mt_rand(0, 0x0fff) | 0x4000,
            mt_rand(0, 0x3fff) | 0x8000,
            mt_rand(0, 0xffff), mt_rand(0, 0xffff), mt_rand(0, 0xffff)
        );
    }

    $randomCookie = generateRandomCookie();


    // Fetch video links
    function fetchVideoLinks($channelUrl, $randomCookie) {
        $curl = curl_init();

        curl_setopt_array($curl, [
            CURLOPT_URL => 'https://tubepilot.ai/wp-admin/admin-ajax.php',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => 'action=video_links_extract&yt_url='. urlencode($channelUrl),
            CURLOPT_COOKIE => 'user_identifier='.$randomCookie,
            CURLOPT_HTTPHEADER => [
                'User-Agent: Mozilla/5.0 (Linux; Android 10; Zenfone Max Pro M1 Build/QQ3A.200805.001) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/131.0.6778.135 Mobile Safari/537.36',
                'Accept-Encoding: gzip, deflate, br, zstd',
                'sec-ch-ua-platform: "Android"',
                'x-requested-with: XMLHttpRequest',
                'sec-ch-ua: "Android WebView";v="131", "Chromium";v="131", "Not_A Brand";v="24"',
                'content-type: application/x-www-form-urlencoded; charset=UTF-8',
                'sec-ch-ua-mobile: ?1',
                'origin: https://tubepilot.ai',
                'sec-fetch-site: same-origin',
                'sec-fetch-mode: cors',
                'sec-fetch-dest: empty',
                'referer: https://tubepilot.ai/tools/youtube-channel-video-links-extractor/',
                'accept-language: en-US,en;q=0.9',
                'priority: u=1, i',
            ],
        ]);

        $response = curl_exec($curl);
        $err = curl_error($curl);

        curl_close($curl);

        if ($err) {
            return  'cURL Error #:' . $err;
        } else {
            return $response;
        }
    }

    $response = fetchVideoLinks($channelUrl, $randomCookie);

    // Extract links using regex and create array of videos
    function extractVideoData($response){
        $videoLinks = [];
          preg_match_all('/href=\'([^\']+)\'/i', $response, $matches);
          if (isset($matches[1])) {
            foreach($matches[1] as $link) {
              // Remove si parameter if present
                $link = preg_replace('/(\?|&)si=[^&]*/', '', $link);
                if(preg_match('/v=([a-zA-Z0-9_-]+)/', $link, $idMatches)){
                    $videoId = $idMatches[1];
                    $videoLinks[] = [
                        "videoId"=>$videoId,
                        "link"=>$link,
                        "thumbnail"=>"https://i.ytimg.com/vi/{$videoId}/maxresdefault.jpg"
                   ];
                }
             }
          }
        return $videoLinks;
    }

    $videoData = extractVideoData($response);
      $jsonData = [
        $channelName => [
            $channelId => $videoData
        ]
      ];

    file_put_contents($videoFile,json_encode($jsonData,JSON_PRETTY_PRINT));
    header('Content-Type: application/json');
    echo json_encode(['success' => true]);
    exit();
}
else {
    header('Content-Type: application/json');
    echo json_encode(['success' => false]);
    exit();
}
?>