<?php
        $channels = [];
        $channelsFile = 'channels.json';

        // Load channels from JSON
        if (file_exists($channelsFile)) {
            $channels = json_decode(file_get_contents($channelsFile), true) ?: [];
        }

        // Handle channel addition
        if($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_POST['channelUrl']) && isset($_POST['channelName'])) {
             $channelUrl = $_POST['channelUrl'];
             $channelName = $_POST['channelName'];
              $channelIdMatch = preg_match('/UU([a-zA-Z0-9_-]+)/', $channelUrl, $channelIdMatches);
              $channelId = $channelIdMatch ? "UU". $channelIdMatches[1] : uniqid();
               $channels[$channelId] = [
                 'url' => $channelUrl,
                   'name' => $channelName
            ];
                file_put_contents($channelsFile, json_encode($channels,JSON_PRETTY_PRINT));
           }

        // Handle channel deletion
       if(isset($_GET['delete']) && isset($_GET['channel_id'])) {
          $channelIdToDelete = $_GET['channel_id'];
           if (isset($channels[$channelIdToDelete])) {
                unset($channels[$channelIdToDelete]);
               file_put_contents($channelsFile, json_encode($channels, JSON_PRETTY_PRINT));
              header('Location: ' . $_SERVER['PHP_SELF']);
                exit();
            }
       }

     ?>
     <!DOCTYPE html>
<html>
<head>
    <title>YouTube Channel Videos</title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <style>
    
    body {
    background-color: #e7e5e6;
    display: block;
    align-items: center;
    justify-content: center;
    height: auto;
    padding: 20px;
}

h1 {
    text-align: center;
    margin-bottom: 20px;
}

#channelForm {
    margin-bottom: 20px;
    display: flex;
    flex-wrap: wrap;
    gap: 10px;
    align-items: center;
    justify-content: center;
}

#channelForm input{
    padding: 10px;
    border: 1px solid teal;
    border-radius: 8px;
    background: #f0f2f5;
    box-shadow: 8px 8px 17px #d1d2d4, -8px -8px 17px #ffffff;
    flex: 1;
    min-width: 200px;
    box-sizing: border-box;
}

#channelForm button{
    padding: 10px 20px;
    background-color: #4CAF50;
    color: white;
    border: 1px solid black;
    border-radius: 8px;
    cursor: pointer;
    box-shadow: 5px 5px 10px #d1d2d4, -5px -5px 10px #ffffff;
    white-space: nowrap;
}


#channel-list {
    margin-bottom: 2px;
}
#channel-list ul {
        list-style: none;
        padding: 0;  /* Remove default padding */
        display: flex; /* Use flexbox for layout */
        flex-wrap: wrap;
        width:100%;
        gap: 10px;
        justify-content: center; /* Center items horizontally */
    }

 #channel-list li {
    padding: 10px 20px;
    background: #f0f2f5;
    border: 1px solid black;
    border-radius: 8px;
    display: flex;
    align-items: center;
    gap: 10px;
    box-shadow: 5px 5px 10px #d1d2d4, -5px -5px 10px #ffffff;
    margin: 5px;
    box-sizing: border-box;
     width: calc(50% - 10px); /* Two columns, with margin */
    }


#channel-list li a {
    padding: 10px 20px;
    background-color: pink;
    color: white;
    border: 2px solid black;
    border-radius: 8px;
    cursor: pointer;
    box-shadow: 5px 5px 10px #d1d2d4, -5px -5px 10px #ffffff;
    white-space: nowrap;
    text-decoration: none;
    color: #333;
    flex-grow: 1;
}

#channel-list li button{
    padding: 10px 20px;
    background-color: #007bff;
    color: white;
    border: none;
    border-radius: 8px;
    cursor: pointer;
    box-shadow: 5px 5px 10px #d1d2d4, -5px -5px 10px #ffffff;
    white-space: nowrap;
}

#channel-list li .delete-btn {
    background-color: #dc3545;
    margin-left: 5px;
}
 /* Media query for screens smaller than 600px */
    @media (max-width: 600px) {
        #channelForm input,
        #channelForm button,
       #channel-list li button{
            padding: 8px;
         font-size: 0.9rem;
        }
        #channel-list li {
            flex-direction: column; /* Stack items vertically on small screens */
            text-align: center;
             width: 99%; /* One column, full width on small screens */
        }
        #channel-list ul {
                flex-direction: column; /* Stack items vertically on small screens */
         }
   }
    </style>
</head>
<body>
    <h1>Videos List</h1>
    <form id="channelForm" method="post">
         <label for="channelName">Enter Channel Name:</label>
        <input type="text" id="channelName" name="channelName" required>
          <label for="channelUrl">Enter YouTube Channel Link:</label>
          <input type="text" id="channelUrl" name="channelUrl" required>
        <button type="submit">Add Channel</button>
    </form>
    <div id="channel-list">
      <?php
        if(!empty($channels)) {
            echo "<h2>Available Channels</h2>";
             echo "<ul>";
              foreach ($channels as $id => $channel) {
               $channelName = isset($channel['name']) ? htmlspecialchars($channel['name']) : 'Unnamed Channel';
                echo "<li>";
                echo "<a href='viewChannel.php?id=" . urlencode($id) . "'>" . $channelName . "</a>";
                    echo "<button onclick='fetchVideos(this, \"" . urlencode($id) . "\",\"" . urlencode($channel['url']) . "\",\"" . urlencode($channelName) . "\")'>Fetch Videos</button>";
                    echo "<button class='delete-btn' onclick='deleteChannel(\"" . urlencode($id) . "\")'>Delete</button>";

                   echo "</li>";
                }
             echo "</ul>";
          }
     ?>
    </div>
    <script>
          function deleteChannel(channelId) {
           if(confirm('Are you sure you want to delete this channel?')){
            window.location.href = '?delete=true&channel_id=' + channelId;
             }
        }
         async function fetchVideos(button, channelId,channelUrl,channelName) {
            const listItem = button.closest('li');
              try {
                   const response = await fetch('fetch_videos.php', {
                     method: 'POST',
                      headers: {
                         'Content-Type': 'application/x-www-form-urlencoded'
                         },
                     body: `channelId=${channelId}&channelUrl=${channelUrl}&channelName=${channelName}`
                 });
                if(response.ok) {
                    alert('Videos fetched successfully!');
                   } else {
                     alert('Error fetching videos');
                    }
                } catch (error) {
                  console.error('Error during fetch request: ',error);
                   alert('Error fetching videos, please check console');
             }
         }

    </script>
</body>
</html>