<?php
    echo "<center>";

$jsonurl = 'cache/'.$_GET['id'].'.json';

 $json= file_get_contents($jsonurl);
$book= json_decode($json,true);

          
            // Create a link for each book using its ID
            $bookLink = "ViewBook.php?id=" . htmlspecialchars($book['id']) . "&page=0";

            // Display each book as a card
            echo "<div class='book-card'>";
            if (!empty($book['imageUrl'])) {
                echo "<img src='" . htmlspecialchars($book['imageUrl']) . "' alt='Book Image' class='book-image'/>";
            }
            echo "<h3><a href='" . $bookLink . "'>" . htmlspecialchars($book['bookNameEnglish']) . "</a></h3>";
            echo "<p><strong>Book name in Hindi:</strong> " . htmlspecialchars($book['bookName']) . "</p>";
          //  echo "<p><strong>Average Reading Time:</strong> " . htmlspecialchars($book['averageReadingTime']) . " minutes</p>";
          //  echo "<p><strong>Book Type:</strong> " . htmlspecialchars($book['bookType']) . "</p>";
          //  echo "<p><strong>Average Rating:</strong> " . htmlspecialchars($book['averageRating']) . "</p>";
            echo "<p><strong>About the Book:</strong> " . $book['about'] . "</p>";
            echo "<p><strong>यह किताब किनके लिए है:</strong> " . $book['forWhom'] . "</p>";
            echo "</div>"; // End of book card

    echo "</center>";
?>


<style>
/* Basic reset for mobile-friendly layout */
* {
    margin: 0;
    padding: 0;
    box-sizing: border-box;
}

/* Body styling */
body {
    font-family: Arial, sans-serif;
    padding: 10px;
    line-height: 1.6;
    background-color: #f4f4f4;
    color: #333;
}

/* Container for the page */
.container {
    max-width: 100%;
    padding: 20px;
    margin: auto;
}

/* Heading styles */
h1, h2 {
    font-size: 24px;
    margin-bottom: 10px;
}

/* List styling */
ul {
    list-style-type: none;
    padding: 0;
}

ul li {
    margin-bottom: 10px;
}

a {
    text-decoration: none;
    color: #007bff;
}

/* Style for the button */
button {
    display: inline-block;
    background-color: #007bff;
    color: white;
    padding: 10px 20px;
    border: none;
    border-radius: 4px;
    cursor: pointer;
    font-size: 16px;
    margin-bottom: 20px;
}

button:hover {
    background-color: #0056b3;
}

/* Textarea styling */
textarea {
    width: 100%; /* Full width */
    height: 90%; /* Initial height */
    padding: 10px;
    font-size: 16px;
    border: 1px solid #ccc;
    border-radius: 4px;
    margin-bottom: 20px;
    resize: vertical; /* Allow resizing vertically */
}

/* Make sure it's responsive */
@media (max-width: 768px) {
    h1, h2 {
        font-size: 20px;
    }

    button {
        font-size: 14px;
        padding: 8px 15px;
    }

    textarea {
        font-size: 14px;
        height: 250px; /* Reduce height for smaller screens */
    }
}

@media (max-width: 480px) {
    h1, h2 {
        font-size: 18px;
    }

    button {
        font-size: 12px;
        padding: 6px 10px;
    }

    textarea {
        font-size: 12px;
        height: 200px; /* Further reduce height for very small screens */
    }
}

</style>



<?php
// Function to get cached book data
function getCachedBookData($id, $cacheDir) {
    $cacheFile = $cacheDir . $id . '.json';
    if (file_exists($cacheFile)) {
        $jsonData = file_get_contents($cacheFile);
        return json_decode($jsonData, true);
    }
    return false;
}

// Function to cache book data
function cacheBookData($id, $data, $cacheDir) {
    $cacheFile = $cacheDir . $id . '.json';
    file_put_contents($cacheFile, json_encode($data, JSON_PRETTY_PRINT));
}

// Sanitize GET input
$id = isset($_GET['id']) ? htmlspecialchars($_GET['id']) : null;

if (!$id) {
    die("Invalid book ID");
}

// API URL
$url = 'https://api.tresify.com/books/' . $id . '/summary';

// Cache directory
$cacheDir = 'book/';
if (!is_dir($cacheDir)) {
    mkdir($cacheDir, 0755, true); // Create cache directory if it doesn't exist
}


// Check if the book data is cached
$cachedBook = getCachedBookData($id, $cacheDir);

if ($cachedBook) {
    // Use cached data if available
    $json_data = $cachedBook;
} else {
 
 // Path to token file
$tokenFile = 'token/token.txt';
if (!file_exists($tokenFile)) {
    die("Token file not found");
}

$token = file_get_contents($tokenFile);

 
    // Initialize cURL
    $ch = curl_init();

    // Set cURL options
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_ENCODING, 'gzip');
    curl_setopt($ch, CURLOPT_HTTPHEADER, [
        'Authorization: ' . $token,
        'User-Agent: Dart/3.4 (dart:io)',
        'Accept-Language: en',
        'Content-Type: application/json',
        'Accept-Encoding: gzip'
    ]);

    // Execute cURL request
    $response = curl_exec($ch);

    // Check for cURL errors
    if (curl_errno($ch)) {
        die("Error fetching data: " . curl_error($ch));
    }

    curl_close($ch);

    // Decode the response
    $json_data = json_decode($response, true);

    if (json_last_error() !== JSON_ERROR_NONE) {
        die("Error decoding JSON response: " . json_last_error_msg());
    }

    // Cache the fetched data
    cacheBookData($id, $json_data, $cacheDir);
}

// Check if the JSON data is valid and contains chapters
if (!empty($json_data) && is_array($json_data)) {
    echo '<button onclick="cleanContent()">Remove Brackets and HTML Tags</button>';

    // Initialize a string to store all chapter content
    $all_content = "";

    // Iterate through each chapter in the JSON and concatenate title and content
    foreach ($json_data as $chapter) {
        // Ensure the expected structure exists before accessing it
        if (isset($chapter['serialNo'], $chapter['title'], $chapter['content'])) {
            $all_content .= "Chapter {$chapter['serialNo']}: {$chapter['title']}\n";
            $all_content .= "{$chapter['content']}\n\n";
        }
    }

    // Display the concatenated content in a single editable textarea
    echo "<textarea id='content-box' rows='20' cols='100'>" . htmlspecialchars($all_content) . "</textarea>";
} else {
    echo "<p>Error: Invalid or empty book data.</p>";
}
?>




<script>
// Function to remove text inside brackets and replace HTML tags with line breaks or spaces
function cleanContent() {
    // Get the textarea with id 'content-box'
    let textarea = document.getElementById('content-box');
    
    // Remove text inside brackets including the brackets
    let content = textarea.value.replace(/\[.*?\]|\(.*?\)/g, '');
    
    // Replace <br> and <br/> with new line (\n)
    content = content.replace(/<br\s*\/?>/gi, '\n');
    
    // Replace paragraph tags with double new lines
    content = content.replace(/<\/?p>/gi, '\n');
    
    // Remove all other HTML tags but keep content inside the tags
    content = content.replace(/<[^>]+>/g, '');
    
    // Set the cleaned content back into the textarea
    textarea.value = content;
}
</script>