<?php
// Load or initialize the JSON file
$dataFile = 'cookies.json';
$data = file_exists($dataFile) ? json_decode(file_get_contents($dataFile), true) : [];
$message = "";
$showOtpInput = false;
$email = "";

if (isset($_POST['action'])) {
    if ($_POST['action'] == 'signup') {
        $email = $_POST['email'];
        $password = $email; // Same as email
        $name = $email;

        $curl = curl_init();

        curl_setopt_array($curl, [
            CURLOPT_URL => 'https://stablediffusionweb.com/api/auth.signup?batch=1',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_HEADER => true,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => '{"0":{"json":{"email":"' . $email . '","password":"' . $password . '","name":"' . $name . '","callbackUrl":"https://stablediffusionweb.com/auth/verify"}}}',
            CURLOPT_COOKIE => 'NEXT_LOCALE=en',
        CURLOPT_HTTPHEADER => [
            'User-Agent: Mozilla/5.0 (Linux; Android 10; Zenfone Max Pro M1 Build/QQ3A.200805.001) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/131.0.6778.135 Mobile Safari/537.36',
            'Accept-Encoding: gzip, deflate, br, zstd',
            'Content-Type: application/json',
            'sec-ch-ua-platform: "Android"',
            'sec-ch-ua: "Android WebView";v="131", "Chromium";v="131", "Not_A Brand";v="24"',
            'sec-ch-ua-mobile: ?1',
            'origin: https://stablediffusionweb.com',
            'x-requested-with: mark.via.gp',
            'sec-fetch-site: same-origin',
            'sec-fetch-mode: cors',
            'sec-fetch-dest: empty',
            'referer: https://stablediffusionweb.com/auth/signup',
            'accept-language: en-US,en;q=0.9',
            'priority: u=1, i',
        ],
        ]);

        $response = curl_exec($curl);
        $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        $header_size = curl_getinfo($curl, CURLINFO_HEADER_SIZE);
        $headers = substr($response, 0, $header_size);
        $err = curl_error($curl);

        curl_close($curl);

        if ($err || $http_code !== 200) {
            $message = "Error: " . ($err ?: $response);
        } else {
              // Extract auth_session cookie
            if (preg_match('/auth_session=([^;]+)/', $headers, $matches)) {
                $auth_session = $matches[1];
                $data[$email] = ['cookie' => $auth_session];
                file_put_contents($dataFile, json_encode($data, JSON_PRETTY_PRINT));
                $message = "Signup successful! Please verify OTP.";
                $showOtpInput = true;
            } else {
                $message = "No auth_session cookie found.";
            }
           
        }
    } else if ($_POST['action'] == 'otpverify') {
        $email = $_POST['email'];
        $otp = $_POST['otp'];

        if (!isset($data[$email])) {
            $message = "Error: No signup data found for this email.";
        } else {
          $auth_session = $data[$email]['cookie'];

          $postFields = '{"0":{"json":{"code":"' . $otp . '","type":"SIGNUP","identifier":"' . $email . '"}}}';

          $curl = curl_init();

          curl_setopt_array($curl, [
              CURLOPT_URL => 'https://stablediffusionweb.com/api/auth.verifyOtp?batch=1',
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_HEADER => true,
              CURLOPT_CUSTOMREQUEST => 'POST',
              CURLOPT_POSTFIELDS => $postFields,
              CURLOPT_COOKIE => 'NEXT_LOCALE=en; auth_session=' . $auth_session,
          CURLOPT_HTTPHEADER => [
          'User-Agent: Mozilla/5.0 (Linux; Android 10; Zenfone Max Pro M1 Build/QQ3A.200805.001) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/131.0.6778.135 Mobile Safari/537.36',
       //   'Accept-Encoding: gzip, deflate, br, zstd',
          'Content-Type: application/json',
          'sec-ch-ua-platform: "Android"',
          'sec-ch-ua: "Android WebView";v="131", "Chromium";v="131", "Not_A Brand";v="24"',
          'sec-ch-ua-mobile: ?1',
          'origin: https://stablediffusionweb.com',
          'x-requested-with: mark.via.gp',
          'sec-fetch-site: same-origin',
          'sec-fetch-mode: cors',
          'sec-fetch-dest: empty',
          'referer: https://stablediffusionweb.com/auth/otp?type=SIGNUP&redirectTo=%2Fapp&identifier=$email',
          'accept-language: en-US,en;q=0.9',
          'priority: u=1, i',
        ],
          ]);

          $response = curl_exec($curl);
          $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
          $header_size = curl_getinfo($curl, CURLINFO_HEADER_SIZE);
          $headers = substr($response, 0, $header_size);
          $body = substr($response, $header_size);
          $err = curl_error($curl);

          curl_close($curl);

          if ($err || $http_code !== 200) {
              $message = "Error: " . ($err ?: $response);
          } else {
              // Extract new auth_session cookie and update JSON
              if (preg_match('/auth_session=([^;]+)/', $headers, $matches)) {
                  $new_auth_session = $matches[1];
                  $data[$email]['cookie'] = $new_auth_session;
              }

               // Parse response and update user data
              $responseData = json_decode($body, true);
              if (isset($responseData[0]['result']['data']['json'])) {
                  $userData = $responseData[0]['result']['data']['json'];
                  $data[$email]['user'] = $userData['user'];
                  $data[$email]['sessionId'] = $userData['sessionId'];
                   $data[$email]['state'] = $userData['state'];
                     $data[$email]['activePeriodExpiresAt'] = $userData['activePeriodExpiresAt'];
                  $data[$email]['idlePeriodExpiresAt'] = $userData['idlePeriodExpiresAt'];
                  file_put_contents($dataFile, json_encode($data, JSON_PRETTY_PRINT));
                  $message =  "OTP Verified Successfully. User data and updated cookie saved.";
                  $showOtpInput = false;
              } else {
                 $message = "Error verifying OTP: " . $response;
              }
            }
        }
    }
}


?>
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Signup and OTP Verification</title>
     <style>
        body {
            font-family: 'Arial', sans-serif;
            display: flex;
            flex-direction: column;
            align-items: center;
            justify-content: center;
            min-height: 100vh;
             margin: 20px;
            background-color: #f0f0f0;
            color: #333;
        }

        h1 {
            color: #2c3e50;
            margin-bottom: 20px;
            text-align: center;
        }
        .form-container {
            display: flex;
            flex-direction: column;
            align-items: center;
        }
        form {
            background-color: #f0f0f0;
            padding: 20px;
            border-radius: 15px;
            box-shadow: 5px 5px 10px #bebebe, -5px -5px 10px #ffffff;
            width: 90%;
            max-width: 300px;
            display: flex;
            flex-direction: column;
            align-items: center;
            transition: transform 0.3s ease-in-out;
            margin-bottom: 20px;
            box-sizing: border-box;
             display: none;
        }
        form.show{
            display: flex;
          }
         form:hover {
           transform: scale(1.02);
         }

        label {
           display: block;
          margin-bottom: 8px;
           color: #555;
        }

        input[type="email"],
         input[type="text"] {
             width: calc(100% - 22px);
             padding: 10px;
             margin-bottom: 15px;
             border: none;
              border-radius: 10px;
               box-sizing: border-box;
                 background: #e0e0e0;
                box-shadow: inset 5px 5px 10px #bebebe, inset -5px -5px 10px #ffffff;
               transition: border-color 0.3s ease;
                outline: none;
          }


         button {
             background-color: #f0f0f0;
            color: #2c3e50;
            padding: 10px 15px;
             border: none;
            border-radius: 10px;
              box-shadow: 5px 5px 10px #bebebe, -5px -5px 10px #ffffff;
           cursor: pointer;
            transition: background-color 0.3s ease;
           margin-bottom: 10px;
             outline: none;
        }
        button:hover {
           background-color: #e0e0e0;
        }
        .message {
            text-align: center;
            color: #27ae60;
            margin-top: 5px;
           font-size: 1.1em;
         }

        .error {
            text-align: center;
            color: #e74c3c;
             margin-top: 5px;
             font-size: 1.1em;
          }

        .email-list {
             margin-top: 20px;
             text-align: center;
        }
       .email-list ul {
            list-style: none;
            padding: 0;
         }

        .email-list li {
             margin-bottom: 10px;
            display: flex;
               justify-content: space-between;
               align-items: center;
            padding: 10px;
             border-radius: 10px;
               background: #f0f0f0;
              box-shadow:  5px 5px 10px #bebebe, -5px -5px 10px #ffffff;
         }
        .email-list li a {
             color: #3498db;
             text-decoration: none;
            transition: color 0.3s ease;
          }
         .email-list li a:hover {
             color: #217dbb;
         }
       .login-btn {
            background-color: #2ecc71;
               color: white;
               padding: 8px 12px;
               border: none;
               border-radius: 4px;
                cursor: pointer;
              text-decoration: none;
                transition: background-color 0.3s ease;
      }
       .login-btn:hover{
          background-color: #27ae60;
       }
         .popup {
            display: none;
             position: fixed;
            top: 50%;
           left: 50%;
             transform: translate(-50%, -50%);
           background-color: white;
           padding: 20px;
           border-radius: 8px;
           box-shadow: 0 4px 8px rgba(0, 0, 0, 0.2);
             z-index: 1000;
             text-align: center;
               border: 1px solid #ddd;
          }
          .popup.show{
             display: block;
         }
        .popup button{
              margin-top: 10px;
          }

         .toggle-signup {
           background-color: #f0f0f0;
               color: #2c3e50;
                padding: 8px 12px;
                 border: none;
                border-radius: 4px;
                  box-shadow: 5px 5px 10px #bebebe, -5px -5px 10px #ffffff;
               cursor: pointer;
                text-decoration: none;
                 transition: background-color 0.3s ease;
              margin-bottom: 10px;
                outline: none;
          }
           .toggle-signup:hover{
             background-color: #e0e0e0;
           }
        #last-used-email {
            background-color: #f0f0f0;
            padding: 10px;
             border-radius: 10px;
             box-shadow: 5px 5px 10px #bebebe, -5px -5px 10px #ffffff;
            margin-bottom: 10px;
              text-align: center;
               width: 90%;
            max-width: 600px;
              box-sizing: border-box;
        }
        #last-used-email a{
          color: #3498db;
            text-decoration: none;
           transition: color 0.3s ease;
        }
       #last-used-email a:hover{
         color: #217dbb;
       }


    </style>
</head>
<body>
  <div id="loginPopup" class="popup">
    <p id="popupMessage"></p>
     <button onclick="closePopup()">Close</button>
 </div>
    <div class="form-container">
       <button class="toggle-signup" onclick="toggleSignupForm()">Show Signup Form</button>
      <form action="index.php" method="POST" class="form-slide-up" id="signupForm">
          <h1>Signup</h1>
            <input type="hidden" name="action" value="signup">
            <label for="email">Email:</label>
            <input type="email" id="email" name="email" value="<?php echo $email; ?>" required>

            <?php if ($showOtpInput): ?>
              <label for="otp">OTP:</label>
              <input type="text" id="otp" name="otp" required>
                <input type="hidden" name="action" value="otpverify">
            <?php endif; ?>

            <button type="submit"><?php echo $showOtpInput ? 'Verify OTP' : 'Signup'; ?></button>
             <?php if ($message): ?>
              <div class="<?php echo strpos($message, 'Error') !== false ? 'error' : 'message'; ?>"><?php echo $message; ?></div>
            <?php endif; ?>
        </form>

    </div>
     <div id="last-used-email"></div>
   <div class="email-list">
    <?php
    if (!empty($data)) {
         echo "<h2>Registered Emails</h2>";
           echo "<ul>";
           $i=1;
           foreach ($data as $email => $value) {
          echo "<li><span>".$i++ .".</span><a href='display.php?email=" . urlencode($email) . "' onclick='updateLastUsedEmail(\"" . htmlspecialchars($email) . "\")'>" . htmlspecialchars($email) . "</a>
                    <a href='authLoginWithPassword.php?email=" . urlencode($email) . "' class='login-btn' onclick='loginUser(event,this,\"" . htmlspecialchars($email) . "\")'>Login</a>
                 </li>";
             }
         echo "</ul>";
    }
    ?>
</div>
    <script>
         // Store email in local storage
        const emailInput = document.querySelector('input[name="email"]');
        if (emailInput) {
            emailInput.addEventListener('input', () => {
                localStorage.setItem('signupEmail', emailInput.value);
            });
        }

         // Check and set stored email in form
         document.addEventListener('DOMContentLoaded', () => {
            const storedEmail = localStorage.getItem('signupEmail');
            if (storedEmail && emailInput) {
                emailInput.value = storedEmail;
            }
             displayLastUsedEmail();
        });
          function displayLastUsedEmail() {
             const lastUsedEmail = localStorage.getItem('lastClickedEmail');
              const lastUsedEmailDiv = document.getElementById('last-used-email');
              if (lastUsedEmail) {
                   lastUsedEmailDiv.innerHTML = '<a href="display.php?email=' + encodeURIComponent(lastUsedEmail) + '">Last Used Email: ' + lastUsedEmail + '</a>';
                 } else {
                      lastUsedEmailDiv.innerHTML = 'No Email Clicked';
                 }
        }

         function updateLastUsedEmail(email) {
               localStorage.setItem('lastClickedEmail', email);
                displayLastUsedEmail();
          }



        function loginUser(event, element, email){
            event.preventDefault();
             const loginPopup = document.getElementById('loginPopup');
             const popupMessage = document.getElementById('popupMessage');
             const loginUrl = element.getAttribute('href');

             fetch(loginUrl)
               .then(response=>response.json())
               .then(data=>{
                  if(data.success){
                    popupMessage.textContent = data.success;
                     loginPopup.classList.add('show');
                     localStorage.setItem('lastClickedEmail', email);
                     window.location.href = `display.php?email=${encodeURIComponent(email)}`;
                  } else if (data.error){
                     popupMessage.textContent = data.error;
                    loginPopup.classList.add('show');
                  }else{
                       popupMessage.textContent = 'Unknown error occurred';
                      loginPopup.classList.add('show');
                  }
              })
              .catch(error => {
                   popupMessage.textContent = 'Error occurred while login';
                   loginPopup.classList.add('show');
                   console.error('Error:', error);
               });
        }
        function closePopup() {
          document.getElementById('loginPopup').classList.remove('show');
        }
         function toggleSignupForm() {
            const signupForm = document.getElementById('signupForm');
            signupForm.classList.toggle('show');
        }
    </script>
</body>
</html>