

 
 
 
<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);
ini_set('memory_limit', '256M');

$mainurl = "https://quickread.com/category/entrepreneurship/7?page=1";
//$mainurl = @file_get_contents('url');



// Function to fetch HTML content using cURL
function fetch_html($url) {
    // Generate a safe filename based on the URL
    $cacheFile = 'cache/' . md5($url) . '.html';
    $cacheDuration = 24 * 60 * 60; // 24 hours in seconds

    // Check if the cache file exists and is recent
    if (file_exists($cacheFile) && (time() - filemtime($cacheFile)) < $cacheDuration) {
        // Serve from cache
        return file_get_contents($cacheFile);
    }

    // Fetch the content with cURL if cache is not available or expired
    $ch = curl_init();
    // Set cURL options
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true); // Follow redirects
    curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0'); // Optional: set a user agent
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true); // Verify SSL peer
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2); // Verify SSL host
    curl_setopt($ch, CURLOPT_SSLVERSION, CURL_SSLVERSION_TLSv1_2); // Use TLS 1.2

    // Execute cURL request
    $html = curl_exec($ch);

    // Check for errors
    if (curl_errno($ch)) {
        echo 'cURL error: ' . curl_error($ch);
        curl_close($ch);
        return false;
    }

    // Close cURL session
    curl_close($ch);

    // Save fetched content to cache file
    file_put_contents($cacheFile, $html);

    return $html;
}



// Determine the URL to fetch based on query parameters
if (isset($_GET['q'])) {
    $url = $mainurl . "search.php?q=" . urlencode($_GET['q']);
} elseif (isset($_GET['url'])) {
    $url = base64_decode($_GET['url']);
} else {
    $url = $mainurl;
}

// Fetch HTML content using cURL
echo $html = fetch_html($url);

// Check if content was retrieved successfully
if ($html === false) {
    die('Error: Unable to retrieve the HTML content from the URL.');
}

// Create a new DOMDocument instance
$dom = new DOMDocument;
libxml_use_internal_errors(true); // Suppress errors related to HTML parsing
$dom->loadHTML($html, LIBXML_HTML_NODEFDTD | LIBXML_HTML_NOIMPLIED);

// Output all CSS styles
$styleSheets = $dom->getElementsByTagName('style');
foreach ($styleSheets as $style) {
    echo $dom->saveHTML($style);
}

// Find and print linked stylesheets
$links = $dom->getElementsByTagName('link');
foreach ($links as $link) {
    if ($link->getAttribute('rel') === 'stylesheet') {
        $cssUrl = $link->getAttribute('href');
        echo "<link rel='stylesheet' type='text/css' href='" . htmlspecialchars($cssUrl) . "' />";
    }
}

// Use XPath to target specific elements by ID or class
$xpath = new DOMXPath($dom);

// Define an array of selectors
$selectors = [
    '.Layout_content__3j6Br',
    '.blog-grid',
    '.right-block',
    '.thumbnail',
    '.entry-content'
];

// Flag to check if entry-meta was found
$entryMetaFound = false;

// Process each selector
foreach ($selectors as $selector) {
    // Select elements using XPath
    if ($selector[0] === '.') {
        $elements = $xpath->query("//*[contains(concat(' ', normalize-space(@class), ' '), ' " . substr($selector, 1) . " ')]");
    } elseif ($selector[0] === '#') {
        $elements = $xpath->query("//*[@id='" . substr($selector, 1) . "']");
    }

    // Loop through matched elements
    foreach ($elements as $element) {
        // If entry-meta is found, modify href attributes and forms, then print and break
        if ($selector === '.entry-meta') {
            $entryMetaFound = true;

            // Modify href attributes within the matched element
            $links = $element->getElementsByTagName('a');
            foreach ($links as $link) {
                $href = $link->getAttribute('href');
                $decodedHref = urldecode($href);

                if (strpos($href, 'https://allset.lol') === 0) {
                    $link->setAttribute('href', 'download.php?url=' . base64_encode($href));
                } elseif (preg_match('/^https:\/\/allset\.lol\/([0-9A-Za-z]+)/', $decodedHref, $matches)) {
                    $link->setAttribute('href', "download.php?url=" . base64_encode($matches[0] . '?download=pixal'));
                } elseif (strpos($href, '/') === 0) {
                    $link->setAttribute('href', '?url=' . base64_encode($mainurl . $href));
                } elseif (strpos($href, 'https://') === 0) {
                    $link->setAttribute('href', '?url=' . base64_encode($href));
                }
            }

            // Update form action attributes within the matched element
            $forms = $element->getElementsByTagName('form');
            foreach ($forms as $form) {
                $action = $form->getAttribute('action');

                if (strpos($action, $mainurl . 'search.php') !== false) {
                    $form->setAttribute('action', '?url=' . base64_encode(parse_url($action, PHP_URL_PATH)));
                } elseif (strpos($action, $mainurl . 'search.php') === false) {
                    $form->setAttribute('action', 'index.php');
                }
            }

            // Print the modified entry-meta element
            echo $dom->saveHTML($element);
            break 2; // Break out of both loops if entry-meta is found
        }
    }

    // If entry-meta was found, no need to check further selectors
    if ($entryMetaFound) {
        break;
    }
}

// If entry-meta was not found, continue with other selectors
if (!$entryMetaFound) {
    foreach ($selectors as $selector) {
        if ($selector === '.entry-meta') {
            continue; // Skip entry-meta since it's already checked
        }

        // Select elements using XPath
        if ($selector[0] === '.') {
            $elements = $xpath->query("//*[contains(concat(' ', normalize-space(@class), ' '), ' " . substr($selector, 1) . " ')]");
        } elseif ($selector[0] === '#') {
            $elements = $xpath->query("//*[@id='" . substr($selector, 1) . "']");
        }

        // Loop through matched elements
        foreach ($elements as $element) {
            // Modify href attributes within the matched element
            $links = $element->getElementsByTagName('a');
            foreach ($links as $link) {
                $href = $link->getAttribute('href');
                $decodedHref = urldecode($href);

                if (strpos($href, 'https://allset.lol') === 0) {
                    $link->setAttribute('href', 'download.php?url=' . base64_encode($href));
                } elseif (preg_match('/^https:\/\/allset\.lol\/([0-9A-Za-z]+)/', $decodedHref, $matches)) {
                    $link->setAttribute('href', "download.php?url=" . base64_encode($matches[0] . '?download=pixal'));
                } elseif (strpos($href, '/') === 0) {
                    $link->setAttribute('href', '?url=' . base64_encode($mainurl . $href));
                } elseif (strpos($href, 'https://') === 0) {
                    $link->setAttribute('href', '?url=' . base64_encode($href));
                }
            }

            // Update form action attributes within the matched element
            $forms = $element->getElementsByTagName('form');
            foreach ($forms as $form) {
                $action = $form->getAttribute('action');

                if (strpos($action, $mainurl . 'search.php') !== false) {
                    $form->setAttribute('action', '?url=' . parse_url($action, PHP_URL_PATH));
                } elseif (strpos($action, $mainurl . 'search.php') === false) {
                    $form->setAttribute('action', 'index.php');
                }
            }

            // Print the modified matched element
            echo $dom->saveHTML($element);
            break; // Exit the loop after printing the first found element
        }
    }
}
?>

<script>
document.addEventListener("DOMContentLoaded", function() {
    function loadLazyImages() {
        // Select all images with the class 'wp-post-image' within elements that have the class 'thumbnail'
        const images = document.querySelectorAll('.thumbnail img.wp-post-image');

        images.forEach(img => {
            // Check if the src is still the placeholder SVG
            if (img.getAttribute("src").includes("data:image/svg+xml")) {
                // Set the actual image source from the data-lazy-src attribute
                const lazySrc = img.getAttribute("data-lazy-src");
                if (lazySrc) {
                    img.src = lazySrc;
                }
            }

            // Add an onerror fallback to handle broken images
            img.onerror = function() {
                img.src = "https://hindi.readersbooksclub.com/wp-content/uploads/2023/11/12-Power-Principles-for-Success-270x270.png";
            };
        });
    }

    // Run on page load
    loadLazyImages();

    // Also run on scroll to trigger loading as images come into view
    window.addEventListener("scroll", loadLazyImages);

    // Run on resize as well, in case images appear/disappear due to layout changes
    window.addEventListener("resize", loadLazyImages);
});

</script>