<meta name="viewport" content="width=device-width, initial-scale=1">

<style>
/* Basic reset for mobile-friendly layout */
* {
    margin: 0;
    padding: 0;
    box-sizing: border-box;
}

/* Body styling */
body {
    font-family: Arial, sans-serif;
    padding: 10px;
    line-height: 1.6;
    background-color: #f4f4f4;
    color: #333;
}

/* Container for the page */
.container {
    max-width: 100%;
    padding: 20px;
    margin: auto;
}

/* Heading styles */
h1, h2 {
    font-size: 24px;
    margin-bottom: 10px;
}

/* List styling */
ul {
    list-style-type: none;
    padding: 0;
}

ul li {
    margin-bottom: 10px;
}

a {
    text-decoration: none;
    color: #007bff;
}

/* Style for the button */
button {
    display: inline-block;
    background-color: #007bff;
    color: white;
    padding: 10px 20px;
    border: none;
    border-radius: 4px;
    cursor: pointer;
    font-size: 16px;
    margin-bottom: 20px;
}

button:hover {
    background-color: #0056b3;
}

/* Textarea styling */
textarea {
    width: 100%; /* Full width */
    height: 90%; /* Initial height */
    padding: 10px;
    font-size: 16px;
    border: 1px solid #ccc;
    border-radius: 4px;
    margin-bottom: 20px;
    resize: vertical; /* Allow resizing vertically */
}

/* Make sure it's responsive */
@media (max-width: 768px) {
    h1, h2 {
        font-size: 20px;
    }

    button {
        font-size: 14px;
        padding: 8px 15px;
    }

    textarea {
        font-size: 14px;
        height: 250px; /* Reduce height for smaller screens */
    }
}

@media (max-width: 480px) {
    h1, h2 {
        font-size: 18px;
    }

    button {
        font-size: 12px;
        padding: 6px 10px;
    }

    textarea {
        font-size: 12px;
        height: 90%; /* Further reduce height for very small screens */
    }
}
#content-box {
    white-space: pre-wrap;
    font-family: monospace;
}

</style>


<body style="margin:10px">
<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);
ini_set('memory_limit', '256M');

$mainurl = "https://hindi.readersbooksclub.com/";
//$mainurl = @file_get_contents('url');



// Function to fetch HTML content using cURL
function fetch_html($url) {
    // Generate a safe filename based on the URL
    $cacheFile = 'cache/' . md5($url) . '.html';
    $cacheDuration = 24 * 60 * 60; // 24 hours in seconds

    // Check if the cache file exists and is recent
    if (file_exists($cacheFile) && (time() - filemtime($cacheFile)) < $cacheDuration) {
        // Serve from cache
        return file_get_contents($cacheFile);
    }

    // Fetch the content with cURL if cache is not available or expired
    $ch = curl_init();
    // Set cURL options
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true); // Follow redirects
    curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0'); // Optional: set a user agent
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true); // Verify SSL peer
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2); // Verify SSL host
    curl_setopt($ch, CURLOPT_SSLVERSION, CURL_SSLVERSION_TLSv1_2); // Use TLS 1.2

    // Execute cURL request
    $html = curl_exec($ch);

    // Check for errors
    if (curl_errno($ch)) {
        echo 'cURL error: ' . curl_error($ch);
        curl_close($ch);
        return false;
    }

    // Close cURL session
    curl_close($ch);

    // Save fetched content to cache file
    file_put_contents($cacheFile, $html);

    return $html;
}



// Determine the URL to fetch based on query parameters
if (isset($_GET['q'])) {
    $url = $mainurl . "search.php?q=" . urlencode($_GET['q']);
} elseif (isset($_GET['url'])) {
    $url = base64_decode($_GET['url']);
} else {
    $url = $mainurl;
}

// Fetch HTML content using cURL
$html = fetch_html($url);

// Check if content was retrieved successfully
if ($html === false) {
    die('Error: Unable to retrieve the HTML content from the URL.');
}

// Create a new DOMDocument instance
$dom = new DOMDocument;
libxml_use_internal_errors(true); // Suppress errors related to HTML parsing
$dom->loadHTML($html, LIBXML_HTML_NODEFDTD | LIBXML_HTML_NOIMPLIED);

// Output all CSS styles
$styleSheets = $dom->getElementsByTagName('style');
foreach ($styleSheets as $style) {
    echo $dom->saveHTML($style);
}

// Find and print linked stylesheets
$links = $dom->getElementsByTagName('link');
foreach ($links as $link) {
    if ($link->getAttribute('rel') === 'stylesheet') {
        $cssUrl = $link->getAttribute('href');
        echo "<link rel='stylesheet' type='text/css' href='" . htmlspecialchars($cssUrl) . "' />";
    }
}

// Use XPath to target specific elements by ID or class
$xpath = new DOMXPath($dom);

$images = $xpath->query('//div[contains(@class, "thumbnail")]//img[@data-lazy-src]');

foreach ($images as $img) {
    // Get the current src value
    $src = $img->getAttribute('src');

    // Check if the src is a placeholder SVG
    if (strpos($src, 'data:image/svg+xml') !== false) {
        // Replace src with data-lazy-src
        $lazySrc = $img->getAttribute('data-lazy-src');
        if ($lazySrc) {
            $img->setAttribute('src', $lazySrc);
            // Remove data-lazy-src and data-lazy-srcset attributes
            $img->removeAttribute('data-lazy-src');
            $img->removeAttribute('data-lazy-srcset');
        }
    }
}
// Define an array of selectors
$selectors = [
    '.categories',
    '.blog-grid',
    '.right-block',
    '.thumbnail',
    '.entry-content'
];

// Flag to check if entry-meta was found
$entryMetaFound = false;
echo "<textarea id='content-box'>";

// Process each selector
foreach ($selectors as $selector) {
    // Select elements using XPath
    if ($selector[0] === '.') {
        $elements = $xpath->query("//*[contains(concat(' ', normalize-space(@class), ' '), ' " . substr($selector, 1) . " ')]");
    } elseif ($selector[0] === '#') {
        $elements = $xpath->query("//*[@id='" . substr($selector, 1) . "']");
    }

    // Loop through matched elements
    foreach ($elements as $element) {
        // If entry-meta is found, modify href attributes and forms, then print and break
        if ($selector === '.categories') {
            $entryMetaFound = true;

            // Modify href attributes within the matched element
            $links = $element->getElementsByTagName('a');
            foreach ($links as $link) {
                $href = $link->getAttribute('href');
                $decodedHref = urldecode($href);

                if (strpos($href, 'https://allset.lol') === 0) {
                    $link->setAttribute('href', 'download.php?url=' . base64_encode($href));
                } elseif (preg_match('/^https:\/\/allset\.lol\/([0-9A-Za-z]+)/', $decodedHref, $matches)) {
                    $link->setAttribute('href', "download.php?url=" . base64_encode($matches[0] . '?download=pixal'));
                } elseif (strpos($href, '/') === 0) {
                    $link->setAttribute('href', '?url=' . base64_encode($mainurl . $href));
                } elseif (strpos($href, 'https://') === 0) {
                    $link->setAttribute('href', '?url=' . base64_encode($href));
                }
            }

            // Update form action attributes within the matched element
            $forms = $element->getElementsByTagName('form');
            foreach ($forms as $form) {
                $action = $form->getAttribute('action');

                if (strpos($action, $mainurl . 'search.php') !== false) {
                    $form->setAttribute('action', '?url=' . base64_encode(parse_url($action, PHP_URL_PATH)));
                } elseif (strpos($action, $mainurl . 'search.php') === false) {
                    $form->setAttribute('action', 'index.php');
                }
            }

            // Print the modified entry-meta element
            echo $dom->saveHTML($element);
            break 2; // Break out of both loops if entry-meta is found
        }
    }

    // If entry-meta was found, no need to check further selectors
    if ($entryMetaFound) {
        break;
    }
}

// If entry-meta was not found, continue with other selectors
if (!$entryMetaFound) {
    foreach ($selectors as $selector) {
        if ($selector === '.entry-meta') {
            continue; // Skip entry-meta since it's already checked
        }

        // Select elements using XPath
        if ($selector[0] === '.') {
            $elements = $xpath->query("//*[contains(concat(' ', normalize-space(@class), ' '), ' " . substr($selector, 1) . " ')]");
        } elseif ($selector[0] === '#') {
            $elements = $xpath->query("//*[@id='" . substr($selector, 1) . "']");
        }

        // Loop through matched elements
        foreach ($elements as $element) {
            // Modify href attributes within the matched element
            $links = $element->getElementsByTagName('a');
            foreach ($links as $link) {
                $href = $link->getAttribute('href');
                $decodedHref = urldecode($href);

                if (strpos($href, 'https://allset.lol') === 0) {
                    $link->setAttribute('href', 'download.php?url=' . base64_encode($href));
                } elseif (preg_match('/^https:\/\/allset\.lol\/([0-9A-Za-z]+)/', $decodedHref, $matches)) {
                    $link->setAttribute('href', "download.php?url=" . base64_encode($matches[0] . '?download=pixal'));
                } elseif (strpos($href, '/') === 0) {
                    $link->setAttribute('href', '?url=' . base64_encode($mainurl . $href));
                } elseif (strpos($href, 'https://') === 0) {
                    $link->setAttribute('href', '?url=' . base64_encode($href));
                }
            }

            // Update form action attributes within the matched element
            $forms = $element->getElementsByTagName('form');
            foreach ($forms as $form) {
                $action = $form->getAttribute('action');

                if (strpos($action, $mainurl . 'search.php') !== false) {
                    $form->setAttribute('action', '?url=' . parse_url($action, PHP_URL_PATH));
                } elseif (strpos($action, $mainurl . 'search.php') === false) {
                    $form->setAttribute('action', 'index.php');
                }
            }

            // Print the modified matched element
           echo $dom->saveHTML($element);
    
            break; // Exit the loop after printing the first found element
        }
    }
}
 echo "</textarea>";
 
    echo '<button onclick="cleanContent()">Remove Brackets and HTML Tags</button>';
    
?>
</body>

<script>
// Function to remove text inside brackets and replace HTML tags with line breaks or spaces
function cleanContent() {
    // Get the textarea with id 'content-box'
    let textarea = document.getElementById('content-box');
    
    // Remove text inside brackets including the brackets
    let content = textarea.value.replace(/\[.*?\]|\(.*?\)/g, '');
    
    // Replace <br> and <br/> with new line (\n)
    content = content.replace(/<br\s*\/?>/gi, '');
    
    // Replace paragraph tags with double new lines
    content = content.replace(/<\/?p>/gi, '');
    
    // Remove all other HTML tags but keep content inside the tags
    content = content.replace(/<[^>]+>/g, '');
    
content = content.replace(/(\r?\n){3,}/g, '\n\n');
    
    // Set the cleaned content back into the textarea
    textarea.value = content;
}
</script>
