<?php

header("Content-Type: application/json");

// Get the video ID from query parameter
$id = $_GET['id'] ?? '';

// Validate video ID
if (empty($id)) {
    echo "Invalid or missing video ID.";
    exit;
}
$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => 'https://notegpt.io/api/v2/video-transcript?platform=youtube&video_id='.$id,
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'GET',
  CURLOPT_COOKIE => 'sbox-guid=MTTczNzAxMzMzNXw2NTl8OTUyMTY0NjUy; anonymous_user_id=a7cf450e4e41a66h9ad66e72488c8d73dd; is_first_visit=true; _trackUserId=G-17370136352000',
  CURLOPT_HTTPHEADER => [
    'User-Agent: Mozilla/5.0 (Linux; Android 10; Zenfone Max Pro M1 Build/QQ3A.200805.001) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/132.0.6834.79 Mobile Safari/537.36',
   // 'Accept-Encoding: gzip, deflate, br, zstd',
    'sec-ch-ua-platform: "Android"',
    'sec-ch-ua: "Not A(Brand";v="8", "Chromium";v="132", "Android WebView";v="132"',
    'sec-ch-ua-mobile: ?1',
    'x-requested-with: mark.via.gp',
    'sec-fetch-site: same-origin',
    'sec-fetch-mode: cors',
    'sec-fetch-dest: empty',
    'referer: https://notegpt.io/youtube-transcript-generator',
    'accept-language: en-US,en;q=0.9',
    'priority: u=1, i',
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);


// Decode the JSON string into a PHP associative array
$data = json_decode($response, true);

// Check if decoding was successful and the array is valid
if ($data === null || !is_array($data)) {
    echo "Error: Invalid JSON data.";
    exit;
}

// Extract the video name
$videoName = $data['data']['videoInfo']['name'];
echo "Video Name: " . $videoName . "\n\n";

// Get the transcripts array
$transcripts = $data['data']['transcripts'];

// Iterate through each language code in the transcripts
foreach ($transcripts as $langCode => $transcriptData) {
     echo "Transcript: " . $langCode . "\n";

     // Iterate through the transcript sections
    foreach($transcriptData['custom'] as $section) {
        echo $section['text'] . " ";
    }
    echo "\n\n";
}

?>